Orxonox: TiXmlElement Class Reference

# TiXmlElement Class Reference

`#include <src/tinyxml/tinyxml.h>`

Inheritance diagram for TiXmlElement:

List of all members.

## Public Member Functions

virtual bool | Accept (TiXmlVisitor *visitor) const
const char * | Attribute (const char *name, double *d) const
const char * | Attribute (const char *name, int *i) const
const char * | Attribute (const char *name) const
virtual TiXmlNode * | Clone () const
| Creates a new Element and returns it - the returned element is a copy.
TiXmlAttribute * | FirstAttribute ()
const TiXmlAttribute * | FirstAttribute () const
| Access the first attribute in this element.
const char * | GetText () const
TiXmlAttribute * | LastAttribute ()
const TiXmlAttribute * | LastAttribute () const
| Access the last attribute in this element.
void | operator= (const TiXmlElement &base)
virtual const char * | Parse (const char *p, TiXmlParsingData *data, TiXmlEncoding encoding)
virtual void | Print (FILE *cfile, int depth) const
int | QueryDoubleAttribute (const char *name, double *_value) const
| QueryDoubleAttribute examines the attribute - see QueryIntAttribute().
int | QueryFloatAttribute (const char *name, float *_value) const
| QueryFloatAttribute examines the attribute - see QueryIntAttribute().
int | QueryIntAttribute (const char *name, int *_value) const
void | RemoveAttribute (const char *name)
void | SetAttribute (const char *name, int value)
void | SetAttribute (const char *name, const char *_value)
void | SetDoubleAttribute (const char *name, double value)
| TiXmlElement (const TiXmlElement &)
| TiXmlElement (const char *in_value)
| Construct an element.
virtual TiXmlElement * | ToElement ()
| Cast to a more defined type. Will return null not of the requested type.
virtual const TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null not of the requested type.
virtual | ~TiXmlElement ()

## Protected Member Functions

void | ClearThis ()
void | CopyTo (TiXmlElement *target) const
const char * | ReadValue (const char *in, TiXmlParsingData *prevData, TiXmlEncoding encoding)

## Private Attributes

TiXmlAttributeSet | attributeSet

## Detailed Description

The element is a container class. It has a value, the element name, and can contain other elements, text, comments, and unknowns. Elements also contain an arbitrary number of attributes.

## Constructor & Destructor Documentation

TiXmlElement::TiXmlElement | ( | const char * | in_value | ) |

Construct an element.

References TiXmlNode::firstChild, TiXmlNode::lastChild, and TiXmlNode::value.

Referenced by Clone().

TiXmlElement::TiXmlElement | ( | const TiXmlElement & | copy | ) |

References CopyTo(), TiXmlNode::firstChild, and TiXmlNode::lastChild.

TiXmlElement::~TiXmlElement | ( |  | ) | `[virtual]`

References ClearThis().

## Member Function Documentation

bool TiXmlElement::Accept | ( | TiXmlVisitor * | visitor | ) | const`[virtual]`

Walk the XML tree visiting this node and all of its children.

Implements TiXmlNode.

References attributeSet, TiXmlAttributeSet::First(), TiXmlNode::FirstChild(), TiXmlVisitor::VisitEnter(), and TiXmlVisitor::VisitExit().

const char * TiXmlElement::Attribute | ( | const char * | name,
|  | double * | d |
| ) |  |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. If the attribute exists and can be converted to an double, the double value will be put in the return 'd', if 'd' is non-null.

References Attribute().

const char * TiXmlElement::Attribute | ( | const char * | name,
|  | int * | i |
| ) |  |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. If the attribute exists and can be converted to an integer, the integer value will be put in the return 'i', if 'i' is non-null.

References Attribute().

const char * TiXmlElement::Attribute | ( | const char * | name | ) | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists.

References attributeSet, TiXmlAttributeSet::Find(), and TiXmlAttribute::Value().

Referenced by Attribute().

void TiXmlElement::ClearThis | ( |  | ) | `[protected]`

References attributeSet, TiXmlNode::Clear(), TiXmlAttributeSet::First(), and TiXmlAttributeSet::Remove().

Referenced by operator=(), and ~TiXmlElement().

TiXmlNode * TiXmlElement::Clone | ( |  | ) | const`[virtual]`

Creates a new Element and returns it - the returned element is a copy.

Implements TiXmlNode.

References CopyTo(), TiXmlElement(), and TiXmlNode::Value().

void TiXmlElement::CopyTo | ( | TiXmlElement * | target | ) | const`[protected]`

References attributeSet, TiXmlNode::Clone(), TiXmlNode::CopyTo(), TiXmlAttributeSet::First(), TiXmlNode::firstChild, TiXmlNode::LinkEndChild(), TiXmlAttribute::Name(), TiXmlAttribute::Next(), TiXmlNode::NextSibling(), SetAttribute(), and TiXmlAttribute::Value().

Referenced by Clone(), operator=(), and TiXmlElement().

TiXmlAttribute* TiXmlElement::FirstAttribute | ( |  | ) | `[inline]`

References attributeSet, and TiXmlAttributeSet::First().

const TiXmlAttribute* TiXmlElement::FirstAttribute | ( |  | ) | const`[inline]`

Access the first attribute in this element.

References attributeSet, and TiXmlAttributeSet::First().

const char * TiXmlElement::GetText | ( |  | ) | const

Convenience function for easy access to the text inside an element. Although easy and concise, GetText() is limited compared to getting the TiXmlText child and accessing it directly.

If the first child of 'this' is a TiXmlText, the GetText() returns the character string of the Text node, else null is returned.

This is a convenient method for getting the text of simple contained text:

    		<foo>This is text</foo>
    		const char* str = fooElement->GetText();

'str' will be a pointer to "This is text".

Note that this function can be misleading. If the element foo was created from this XML:

    		<foo><b>This is text</b></foo>

then the value of str would be null. The first child node isn't a text node, it is another element. From this XML:

    		<foo>This is <b>text</b></foo>

GetText() will return "This is ".

WARNING: GetText() accesses a child node - don't become confused with the similarly named TiXmlHandle::Text() and TiXmlNode::ToText() which are safe type casts on the referenced node.

References TiXmlNode::FirstChild(), TiXmlNode::ToText(), and TiXmlNode::Value().

TiXmlAttribute* TiXmlElement::LastAttribute | ( |  | ) | `[inline]`

References attributeSet, and TiXmlAttributeSet::Last().

const TiXmlAttribute* TiXmlElement::LastAttribute | ( |  | ) | const`[inline]`

Access the last attribute in this element.

References attributeSet, and TiXmlAttributeSet::Last().

void TiXmlElement::operator= | ( | const TiXmlElement & | base | ) |

References ClearThis(), and CopyTo().

const char * TiXmlElement::Parse | ( | const char * | p,
|  | TiXmlParsingData * | data,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[virtual]`

Implements TiXmlBase.

References TiXmlAttributeSet::Add(), attributeSet, TiXmlParsingData::Cursor(), TiXmlAttributeSet::Find(), TiXmlNode::GetDocument(), TiXmlBase::location, TiXmlAttribute::Name(), TiXmlAttribute::NameTStr(), TiXmlAttribute::Parse(), TiXmlBase::ReadName(), ReadValue(), TiXmlAttribute::SetDocument(), TiXmlDocument::SetError(), TiXmlAttribute::SetValue(), TiXmlBase::SkipWhiteSpace(), TiXmlParsingData::Stamp(), TiXmlBase::StringEqual(), TiXmlBase::TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TiXmlBase::TIXML_ERROR_OUT_OF_MEMORY, TiXmlBase::TIXML_ERROR_PARSING_ELEMENT, TiXmlBase::TIXML_ERROR_PARSING_EMPTY, TiXmlBase::TIXML_ERROR_READING_ATTRIBUTES, TiXmlBase::TIXML_ERROR_READING_END_TAG, TIXML_STRING, TiXmlAttribute::Value(), and TiXmlNode::value.

void TiXmlElement::Print | ( | FILE * | cfile,
|  | int | depth |
| ) |  |  | const`[virtual]`

All TinyXml classes can print themselves to a filestream or the string class (TiXmlString in non-STL mode, std::string in STL mode.) Either or both cfile and str can be null.

This is a formatted print, and will insert tabs and newlines.

(For an unformatted stream, use the << operator.)

Implements TiXmlBase.

References attributeSet, TiXmlAttributeSet::First(), TiXmlNode::firstChild, TiXmlNode::lastChild, TiXmlAttribute::Next(), TiXmlNode::NextSibling(), TiXmlBase::Print(), TiXmlNode::ToText(), and TiXmlNode::value.

int TiXmlElement::QueryDoubleAttribute | ( | const char * | name,
|  | double * | _value |
| ) |  |  | const

QueryDoubleAttribute examines the attribute - see QueryIntAttribute().

References attributeSet, TiXmlAttributeSet::Find(), TiXmlAttribute::QueryDoubleValue(), and TIXML_NO_ATTRIBUTE.

Referenced by QueryFloatAttribute().

int TiXmlElement::QueryFloatAttribute | ( | const char * | name,
|  | float * | _value |
| ) |  |  | const`[inline]`

QueryFloatAttribute examines the attribute - see QueryIntAttribute().

References QueryDoubleAttribute(), and TIXML_SUCCESS.

int TiXmlElement::QueryIntAttribute | ( | const char * | name,
|  | int * | _value |
| ) |  |  | const

QueryIntAttribute examines the attribute - it is an alternative to the Attribute() method with richer error checking. If the attribute is an integer, it is stored in 'value' and the call returns TIXML_SUCCESS. If it is not an integer, it returns TIXML_WRONG_TYPE. If the attribute does not exist, then TIXML_NO_ATTRIBUTE is returned.

References attributeSet, TiXmlAttributeSet::Find(), TiXmlAttribute::QueryIntValue(), and TIXML_NO_ATTRIBUTE.

const char * TiXmlElement::ReadValue | ( | const char * | in,
|  | TiXmlParsingData * | prevData,
|  | TiXmlEncoding | encoding |
| ) |  |  | `[protected]`

References TiXmlText::Blank(), TiXmlNode::GetDocument(), TiXmlNode::Identify(), TiXmlBase::IsWhiteSpaceCondensed(), TiXmlNode::LinkEndChild(), TiXmlBase::Parse(), TiXmlText::Parse(), TiXmlDocument::SetError(), TiXmlBase::SkipWhiteSpace(), TiXmlBase::StringEqual(), TiXmlBase::TIXML_ERROR_OUT_OF_MEMORY, and TiXmlBase::TIXML_ERROR_READING_ELEMENT_VALUE.

Referenced by Parse().

void TiXmlElement::RemoveAttribute | ( | const char * | name | ) |

Deletes an attribute with the given name.

References attributeSet, TiXmlAttributeSet::Find(), TiXmlAttributeSet::Remove(), and TIXML_STRING.

void TiXmlElement::SetAttribute | ( | const char * | name,
|  | int | value |
| ) |  |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

References SetAttribute().

void TiXmlElement::SetAttribute | ( | const char * | name,
|  | const char * | _value |
| ) |  |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

References TiXmlAttributeSet::Add(), attributeSet, TiXmlAttributeSet::Find(), TiXmlNode::GetDocument(), TiXmlDocument::SetError(), TiXmlAttribute::SetValue(), TIXML_ENCODING_UNKNOWN, TiXmlBase::TIXML_ERROR_OUT_OF_MEMORY, and TIXML_STRING.

Referenced by CopyTo(), SetAttribute(), and SetDoubleAttribute().

void TiXmlElement::SetDoubleAttribute | ( | const char * | name,
|  | double | value |
| ) |  |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

References SetAttribute().

virtual TiXmlElement* TiXmlElement::ToElement | ( |  | ) | `[inline, virtual]`

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

virtual const TiXmlElement* TiXmlElement::ToElement | ( |  | ) | const`[inline, virtual]`

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

## Member Data Documentation

TiXmlAttributeSet TiXmlElement::attributeSet`[private]`

Referenced by Accept(), Attribute(), ClearThis(), CopyTo(), FirstAttribute(), LastAttribute(), Parse(), Print(), QueryDoubleAttribute(), QueryIntAttribute(), RemoveAttribute(), and SetAttribute().

The documentation for this class was generated from the following files:

- src/tinyxml/tinyxml.h
- src/tinyxml/tinyxml.cpp
- src/tinyxml/tinyxmlparser.cpp